diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/leptprotos.h leptonlib-1.066/src/leptprotos.h
--- leptonlib-1.66/src/leptprotos.h	2010-08-08 04:26:00.000000000 +0300
+++ leptonlib-1.066/src/leptprotos.h	2010-09-23 09:31:36.000000000 +0300
@@ -615,6 +615,10 @@
 LEPT_DLL extern PIX * pixDilateGray ( PIX *pixs, l_int32 hsize, l_int32 vsize );
 LEPT_DLL extern PIX * pixOpenGray ( PIX *pixs, l_int32 hsize, l_int32 vsize );
 LEPT_DLL extern PIX * pixCloseGray ( PIX *pixs, l_int32 hsize, l_int32 vsize );
+LEPT_DLL extern PIX * pixErodeGray3 ( PIX *pixs, l_int32 hsize, l_int32 vsize );
+LEPT_DLL extern PIX * pixDilateGray3 ( PIX *pixs, l_int32 hsize, l_int32 vsize );
+LEPT_DLL extern PIX * pixOpenGray3 ( PIX *pixs, l_int32 hsize, l_int32 vsize );
+LEPT_DLL extern PIX * pixCloseGray3 ( PIX *pixs, l_int32 hsize, l_int32 vsize );
 LEPT_DLL extern void dilateGrayLow ( l_uint32 *datad, l_int32 w, l_int32 h, l_int32 wpld, l_uint32 *datas, l_int32 wpls, l_int32 size, l_int32 direction, l_uint8 *buffer, l_uint8 *maxarray );
 LEPT_DLL extern void erodeGrayLow ( l_uint32 *datad, l_int32 w, l_int32 h, l_int32 wpld, l_uint32 *datas, l_int32 wpls, l_int32 size, l_int32 direction, l_uint8 *buffer, l_uint8 *minarray );
 LEPT_DLL extern PIX * pixDitherToBinary ( PIX *pixs );
@@ -1097,15 +1101,17 @@
 LEPT_DLL extern PIX * pixClipRectangle ( PIX *pixs, BOX *box, BOX **pboxc );
 LEPT_DLL extern PIX * pixClipMasked ( PIX *pixs, PIX *pixm, l_int32 x, l_int32 y, l_uint32 outval );
 LEPT_DLL extern PIX * pixResizeToMatch ( PIX *pixs, PIX *pixt, l_int32 w, l_int32 h );
-LEPT_DLL extern NUMA * pixExtractOnLine ( PIX *pixs, l_int32 x1, l_int32 y1, l_int32 x2, l_int32 y2, l_int32 factor );
-LEPT_DLL extern l_float32 pixAverageOnLine ( PIX *pixs, l_int32 x1, l_int32 y1, l_int32 x2, l_int32 y2, l_int32 factor );
-LEPT_DLL extern NUMA * pixAverageIntensityProfile ( PIX *pixs, l_float32 fract, l_int32 dir, l_int32 first, l_int32 last, l_int32 factor1, l_int32 factor2 );
-LEPT_DLL extern NUMA * pixReversalProfile ( PIX *pixs, l_float32 fract, l_int32 dir, l_int32 first, l_int32 last, l_int32 minreversal, l_int32 factor1, l_int32 factor2 );
 LEPT_DLL extern l_int32 pixClipToForeground ( PIX *pixs, PIX **ppixd, BOX **pbox );
 LEPT_DLL extern l_int32 pixClipBoxToForeground ( PIX *pixs, BOX *boxs, PIX **ppixd, BOX **pboxd );
 LEPT_DLL extern l_int32 pixScanForForeground ( PIX *pixs, BOX *box, l_int32 scanflag, l_int32 *ploc );
 LEPT_DLL extern l_int32 pixClipBoxToEdges ( PIX *pixs, BOX *boxs, l_int32 lowthresh, l_int32 highthresh, l_int32 maxwidth, l_int32 factor, PIX **ppixd, BOX **pboxd );
 LEPT_DLL extern l_int32 pixScanForEdge ( PIX *pixs, BOX *box, l_int32 lowthresh, l_int32 highthresh, l_int32 maxwidth, l_int32 factor, l_int32 scanflag, l_int32 *ploc );
+LEPT_DLL extern NUMA * pixExtractOnLine ( PIX *pixs, l_int32 x1, l_int32 y1, l_int32 x2, l_int32 y2, l_int32 factor );
+LEPT_DLL extern l_float32 pixAverageOnLine ( PIX *pixs, l_int32 x1, l_int32 y1, l_int32 x2, l_int32 y2, l_int32 factor );
+LEPT_DLL extern NUMA * pixAverageIntensityProfile ( PIX *pixs, l_float32 fract, l_int32 dir, l_int32 first, l_int32 last, l_int32 factor1, l_int32 factor2 );
+LEPT_DLL extern NUMA * pixReversalProfile ( PIX *pixs, l_float32 fract, l_int32 dir, l_int32 first, l_int32 last, l_int32 minreversal, l_int32 factor1, l_int32 factor2 );
+LEPT_DLL extern PIX * pixRankRowTransform ( PIX *pixs );
+LEPT_DLL extern PIX * pixRankColumnTransform ( PIX *pixs );
 LEPT_DLL extern PIXA * pixaCreate ( l_int32 n );
 LEPT_DLL extern PIXA * pixaCreateFromPix ( PIX *pixs, l_int32 n, l_int32 cellw, l_int32 cellh );
 LEPT_DLL extern PIXA * pixaCreateFromBoxa ( PIX *pixs, BOXA *boxa, l_int32 *pcropwarn );
@@ -1774,6 +1780,14 @@
 LEPT_DLL extern l_int32 lstackExtendArray ( L_STACK *lstack );
 LEPT_DLL extern l_int32 lstackGetCount ( L_STACK *lstack );
 LEPT_DLL extern l_int32 lstackPrint ( FILE *fp, L_STACK *lstack );
+LEPT_DLL extern l_int32 * sudokuReadFile ( const char *filename );
+LEPT_DLL extern l_int32 * sudokuReadString ( const char *str );
+LEPT_DLL extern L_SUDOKU * sudokuCreate ( l_int32 *array );
+LEPT_DLL extern void sudokuDestroy ( L_SUDOKU **psud );
+LEPT_DLL extern l_int32 sudokuSolve ( L_SUDOKU *sud );
+LEPT_DLL extern l_int32 sudokuTestUniqueness ( l_int32 *array, l_int32 *punique );
+LEPT_DLL extern L_SUDOKU * sudokuGenerate ( l_int32 *array, l_int32 seed, l_int32 minelems, l_int32 maxtries );
+LEPT_DLL extern l_int32 sudokuOutput ( L_SUDOKU *sud, l_int32 arraytype );
 LEPT_DLL extern PIX * pixAddSingleTextblock ( PIX *pixs, L_BMF *bmf, const char *textstr, l_uint32 val, l_int32 location, l_int32 *poverflow );
 LEPT_DLL extern l_int32 pixSetTextblock ( PIX *pixs, L_BMF *bmf, const char *textstr, l_uint32 val, l_int32 x0, l_int32 y0, l_int32 wtext, l_int32 firstindent, l_int32 *poverflow );
 LEPT_DLL extern l_int32 pixSetTextline ( PIX *pixs, L_BMF *bmf, const char *textstr, l_uint32 val, l_int32 x0, l_int32 y0, l_int32 *pwidth, l_int32 *poverflow );
@@ -1851,11 +1865,17 @@
 LEPT_DLL extern char * genTempFilename ( const char *dir, const char *tail, l_int32 usepid );
 LEPT_DLL extern char * mungePathnameForWindows ( const char *namein );
 LEPT_DLL extern l_int32 extractNumberFromFilename ( const char *fname, l_int32 numpre, l_int32 numpost );
+LEPT_DLL extern l_int32 genRandomIntegerInRange ( l_int32 range, l_int32 seed, l_int32 *pval );
 LEPT_DLL extern char * getLeptonlibVersion (  );
 LEPT_DLL extern char * getImagelibVersions (  );
 LEPT_DLL extern void startTimer ( void );
 LEPT_DLL extern l_float32 stopTimer ( void );
 LEPT_DLL extern l_int32 pixHtmlViewer ( const char *dirin, const char *dirout, const char *rootname, l_int32 thumbwidth, l_int32 viewwidth, l_int32 copyorig );
+LEPT_DLL extern PIX * pixReadWebP ( const char *filename );
+LEPT_DLL extern PIX * pixReadStreamWebP ( FILE *fp );
+LEPT_DLL extern l_int32 pixWriteWebP ( const char *filename, PIX *pix, l_int32 quantparam );
+LEPT_DLL extern l_int32 pixWriteStreamWebP ( FILE *fp, PIX *pix, l_int32 quantparam );
+LEPT_DLL extern l_int32 pixWriteWebPwithTargetPSNR ( const char *filename, PIX *pix, l_float64 target_psnr, l_int32 *qp_ptr );
 LEPT_DLL extern PIX * pixSimpleCaptcha ( PIX *pixs, l_int32 border, l_int32 nterms, l_uint32 seed, l_uint32 color, l_int32 cmapflag );
 LEPT_DLL extern PIX * pixRandomHarmonicWarp ( PIX *pixs, l_float32 xmag, l_float32 ymag, l_float32 xfreq, l_float32 yfreq, l_int32 nx, l_int32 ny, l_uint32 seed, l_int32 grayval );
 LEPT_DLL extern PIX * pixWarpStereoscopic ( PIX *pixs, l_int32 zbend, l_int32 zshiftt, l_int32 zshiftb, l_int32 ybendt, l_int32 ybendb, l_int32 redleft );
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/makefile leptonlib-1.066/src/makefile
--- leptonlib-1.66/src/makefile	2010-08-01 01:42:45.000000000 +0300
+++ leptonlib-1.066/src/makefile	2010-09-24 07:27:46.000000000 +0300
@@ -99,8 +99,8 @@
 #        ERROR_* logging, and to remove all DEBUG information dependent
 #        on whether or not NO_CONSOLE_IO has been defined.
 #     - use -D_CYGWIN_ENVIRON (and without -fPIC) for cygwin
-CC =		gcc -ansi -D_BSD_SOURCE -DANSI -fPIC
-#CC =		g++ -D_BSD_SOURCE -fPIC
+#CC =		gcc -ansi -D_BSD_SOURCE -DANSI -fPIC
+CC =		g++ -D_BSD_SOURCE -fPIC
 #CC =		g++ -Wunused -D_BSD_SOURCE -fPIC
 #CC =		gcc -ansi -DNO_CONSOLE_IO -D_BSD_SOURCE -DANSI -fPIC
 #CC =		gcc -ansi -D_CYGWIN_ENVIRON -DANSI
@@ -138,7 +138,7 @@
 #   Links are created among the files <libname>.X.Y,
 #   <libname>.X, and <libname>, where Y is the minor revision number.
 MAJOR_REV = 1
-MINOR_REV = 66
+MINOR_REV = 66a
 
 #########################################################
 
@@ -195,9 +195,11 @@
 		scale.c scalelow.c \
 		seedfill.c seedfilllow.c \
 		sel1.c sel2.c selgen.c \
-		shear.c skew.c spixio.c stack.c \
+		shear.c skew.c spixio.c \
+		stack.c sudoku.c \
 		textops.c tiffio.c tiffiostub.c \
 		utils.c viewfiles.c \
+		webpio.c webpiostub.c \
 		warper.c watershed.c writefile.c \
 		zlibmem.c zlibmemstub.c
 
@@ -210,7 +212,7 @@
 		leptprotos.h list.h \
 		morph.h pix.h ptra.h queue.h \
 		readbarcode.h regutils.h stack.h \
-		watershed.h
+		sudoku.h watershed.h
 
 ##################################################################
 
@@ -256,7 +258,7 @@
 #  xtractprotos
 
 xtractprotos:	dirs leptlib
-	cd ../prog; make xtractprotos
+	cd ../prog; make xtractprotos; cp xtractprotos ../src
 
 xtractprotos.o:	xtractprotos.c
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/makefile.mingw leptonlib-1.066/src/makefile.mingw
--- leptonlib-1.66/src/makefile.mingw	2010-08-01 01:43:54.000000000 +0300
+++ leptonlib-1.066/src/makefile.mingw	2010-09-16 08:46:35.000000000 +0300
@@ -125,7 +125,7 @@
 # Links are created among the files <libname>.X.Y,
 # <libname>.X, and <libname>, where Y is the minor revision number.
 MAJOR_REV = 1
-MINOR_REV = 66
+MINOR_REV = 66a
 
 #########################################################
 
@@ -183,9 +183,11 @@
 		scale.c scalelow.c \
 		seedfill.c seedfilllow.c \
 		sel1.c sel2.c selgen.c \
-		shear.c skew.c spixio.c stack.c \
+		shear.c skew.c spixio.c \
+		stack.c sudoku.c \
 		textops.c tiffio.c tiffiostub.c \
 		utils.c viewfiles.c \
+		vp8io.c vp8iostub.c \
 		warper.c watershed.c writefile.c \
 		zlibmem.c zlibmemstub.c
 
@@ -198,7 +200,7 @@
 		leptprotos.h list.h \
 		morph.h pix.h ptra.h queue.h \
 		readbarcode.h regutils.h stack.h \
-		watershed.h
+		sudoku.h watershed.h
 
 ##################################################################
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/numabasic.c leptonlib-1.066/src/numabasic.c
--- leptonlib-1.66/src/numabasic.c	2010-07-20 00:01:55.000000000 +0300
+++ leptonlib-1.066/src/numabasic.c	2010-09-16 07:54:01.000000000 +0300
@@ -954,7 +954,7 @@
 NUMA *
 numaReadStream(FILE  *fp)
 {
-l_int32    i, n, index, ret, version;
+l_int32    i, n, index, ret, version, ignore;
 l_float32  val, startx, delx;
 NUMA      *na;
 
@@ -968,7 +968,7 @@
         return (NUMA *)ERROR_PTR("not a numa file", procName, NULL);
     if (version != NUMA_VERSION_NUMBER)
         return (NUMA *)ERROR_PTR("invalid numa version", procName, NULL);
-    fscanf(fp, "Number of numbers = %d\n", &n);
+    ignore = fscanf(fp, "Number of numbers = %d\n", &n);
 
     if ((na = numaCreate(n)) == NULL)
         return (NUMA *)ERROR_PTR("na not made", procName, NULL);
@@ -1415,7 +1415,7 @@
 NUMAA *
 numaaReadStream(FILE  *fp)
 {
-l_int32    i, n, index, ret, version;
+l_int32    i, n, index, ret, version, ignore;
 NUMA      *na;
 NUMAA     *naa;
 
@@ -1429,12 +1429,12 @@
         return (NUMAA *)ERROR_PTR("not a numa file", procName, NULL);
     if (version != NUMA_VERSION_NUMBER)
         return (NUMAA *)ERROR_PTR("invalid numaa version", procName, NULL);
-    fscanf(fp, "Number of numa = %d\n\n", &n);
+    ignore = fscanf(fp, "Number of numa = %d\n\n", &n);
     if ((naa = numaaCreate(n)) == NULL)
         return (NUMAA *)ERROR_PTR("naa not made", procName, NULL);
 
     for (i = 0; i < n; i++) {
-        fscanf(fp, "Numa[%d]:", &index);
+        ignore = fscanf(fp, "Numa[%d]:", &index);
         if ((na = numaReadStream(fp)) == NULL)
             return (NUMAA *)ERROR_PTR("na not made", procName, NULL);
         numaaAddNuma(naa, na, L_INSERT);
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/parseprotos.c leptonlib-1.066/src/parseprotos.c
--- leptonlib-1.66/src/parseprotos.c	2009-07-12 04:12:56.000000000 +0300
+++ leptonlib-1.066/src/parseprotos.c	2010-09-09 10:09:13.000000000 +0300
@@ -158,12 +158,22 @@
                 start, stop, charindex); */
         str = captureProtoSignature(sa, start, stop, charindex);
 
-            /* Make sure it is not static.  Note that 'extern' has
-             * been prepended to the prototype, so the 'static'
-             * keyword, if it exists, would be the second word. */
+            /* Make sure that the signature found by cpp is neither
+             * static nor extern.  We get 'extern' declarations from
+             * header files, and with some versions of cpp running on
+             * #include <sys/stat.h> we get something of the form:
+             *    extern ... (( ... )) ... ( ... ) { ...
+             * For this, the 1st '(' is the lp, the 2nd ')' is the rp,
+             * and there is a lot of garbage between the rp and the lb.
+             * It is easiest to simply reject any signature that starts
+             * with 'extern'.  Note also that an 'extern' token has been
+             * prepended to each prototype, so the 'static' or
+             * 'extern' keywords we are looking for, if they exist,
+             * would be the second word. */
         satest = sarrayCreateWordsFromString(str);
         secondword = sarrayGetString(satest, 1, 0);
-        if (strcmp(secondword, "static")) {  /* not static */
+        if (strcmp(secondword, "static") &&  /* not static */
+            strcmp(secondword, "extern")) {  /* not extern */
             if (prestring) {  /* prepend it to the prototype */
                 newstr = stringJoin(prestring, str);
                 sarrayAddString(saout, newstr, L_INSERT);
@@ -454,7 +464,11 @@
             continue;
         }
 
-            /* OK, it should be a function definition */
+            /* OK, it should be a function definition.  We haven't
+             * checked that there is only white space between the
+             * rp and lb, but we've only seen problems with two
+             * extern inlines in sys/stat.h, and this is handled
+             * later by eliminating any prototype beginning with 'extern'. */
         *pstart = next;
         *pstop = next + soffsetrp;
         *pcharindex = boffsetrp;
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pix1.c leptonlib-1.066/src/pix1.c
--- leptonlib-1.66/src/pix1.c	2010-07-31 04:40:58.000000000 +0300
+++ leptonlib-1.066/src/pix1.c	2010-09-15 09:04:16.000000000 +0300
@@ -16,13 +16,14 @@
 /*
  *  pix1.c
  *
- *    The pixN.c {N = 1,2,3,4} files are sorted by the type of operation.
+ *    The pixN.c {N = 1,2,3,4,5} files are sorted by the type of operation.
  *    The primary functions in these files are:
  *
  *        pix1.c: constructors, destructors and field accessors
  *        pix2.c: pixel poking of image, pad and border pixels
  *        pix3.c: masking and logical ops, counting, mirrored tiling
- *        pix4.c: histograms, fg/bg estimation, rectangle extraction
+ *        pix4.c: histograms, statistics, fg/bg estimation
+ *        pix5.c: property measurements, rectangle extraction
  *
  *
  *    This file has the basic constructors, destructors and field accessors
@@ -269,7 +270,7 @@
           l_int32  height,
           l_int32  depth)
 {
-PIX       *pixd;
+PIX  *pixd;
 
     PROCNAME("pixCreate");
 
@@ -326,7 +327,7 @@
 PIX *
 pixCreateTemplate(PIX  *pixs)
 {
-PIX     *pixd;
+PIX  *pixd;
 
     PROCNAME("pixCreateTemplate");
 
@@ -385,8 +386,8 @@
                 l_int32  height,
                 l_int32  depth)
 {
-l_int32    wpl;
-PIX       *pixd;
+l_int32  wpl;
+PIX     *pixd;
 
     PROCNAME("pixCreateHeader");
 
@@ -409,7 +410,6 @@
 
     pixd->refcount = 1;
     pixd->informat = IFF_UNKNOWN;
-
     return pixd;
 }
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pix5.c leptonlib-1.066/src/pix5.c
--- leptonlib-1.66/src/pix5.c	2010-07-20 00:01:57.000000000 +0300
+++ leptonlib-1.066/src/pix5.c	2010-09-15 09:43:51.000000000 +0300
@@ -20,8 +20,9 @@
  *
  *      (1) Measurement of 1 bpp image properties
  *      (2) Extract rectangular region
- *      (3) Extract pixel averages and reversals along lines
- *      (4) Clip to foreground
+ *      (3) Clip to foreground
+ *      (4) Extract pixel averages and reversals along lines
+ *      (5) Rank row and column transforms
  *
  *    Measurement of properties
  *           l_int32     pixaFindDimensions()
@@ -42,18 +43,22 @@
  *           PIX        *pixClipMasked()
  *           PIX        *pixResizeToMatch()
  *
- *    Extract pixel averages and reversals along lines
- *           NUMA       *pixExtractOnLine()
- *           l_float32   pixAverageOnLine();
- *           NUMA       *pixAverageIntensityProfile()
- *           NUMA       *pixReversalProfile()
- *
  *    Clip to foreground
  *           PIX        *pixClipToForeground()
  *           l_int32     pixClipBoxToForeground()
  *           l_int32     pixScanForForeground()
  *           l_int32     pixClipBoxToEdges()
  *           l_int32     pixScanForEdge()
+ *
+ *    Extract pixel averages and reversals along lines
+ *           NUMA       *pixExtractOnLine()
+ *           l_float32   pixAverageOnLine();
+ *           NUMA       *pixAverageIntensityProfile()
+ *           NUMA       *pixReversalProfile()
+ *
+ *    Rank row and column transforms
+ *           PIX        *pixRankRowTransform()
+ *           PIX        *pixRankColumnTransform()
  */
 
 #include <stdio.h>
@@ -875,399 +880,6 @@
 
 
 /*---------------------------------------------------------------------*
- *           Extract pixel averages and reversals along lines          *
- *---------------------------------------------------------------------*/
-/*!
- *  pixExtractOnLine()
- *
- *      Input:  pixs (1 bpp or 8 bpp; no colormap)
- *              x1, y1 (starting pt for line)
- *              x2, y2 (end pt for line)
- *              factor (sampling; >= 1)
- *      Return: na (of pixel values along line), or null on error.
- *
- *  Notes:
- *      (1) The line must be either horizontal or vertical, so either
- *          y1 == y2 (horizontal) or x1 == x2 (vertical).
- *      (2) If horizontal, x1 must be <= x2.
- *          If vertical, y1 must be <= y2.
- *      (3) Input end points are clipped to the pix.
- *      (4) Can be used with numaCountReverals(), for example, to
- *          characterize the intensity smoothness along a line.
- */
-NUMA *
-pixExtractOnLine(PIX     *pixs,
-                 l_int32  x1,
-                 l_int32  y1,
-                 l_int32  x2,
-                 l_int32  y2,
-                 l_int32  factor)
-{
-l_int32   i, w, h, d, direction;
-l_uint32  val;
-NUMA     *na;
-
-    PROCNAME("pixExtractOnLine");
-
-    if (!pixs)
-        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
-    pixGetDimensions(pixs, &w, &h, &d);
-    if (d != 1 && d != 8)
-        return (NUMA *)ERROR_PTR("d not 1 or 8 bpp", procName, NULL);
-    if (pixGetColormap(pixs))
-        return (NUMA *)ERROR_PTR("pixs has a colormap", procName, NULL);
-    if (x1 > x2 || y1 > y2)
-        return (NUMA *)ERROR_PTR("x1 > x2 or y1 > y2", procName, NULL);
-    if (y1 == y2) {
-        x1 = L_MAX(0, x1);
-        x2 = L_MIN(w - 1, x2);
-        y1 = L_MAX(0, L_MIN(y1, h - 1));
-        direction = L_HORIZONTAL_LINE;
-    }
-    else if (x1 == x2) {
-        y1 = L_MAX(0, y1);
-        y2 = L_MIN(h - 1, y2);
-        x1 = L_MAX(0, L_MIN(x1, w - 1));
-        direction = L_VERTICAL_LINE;
-    }
-    if (y1 == y2)
-        direction = L_HORIZONTAL_LINE;
-    else if (x1 == x2)
-        direction = L_VERTICAL_LINE;
-    else
-        return (NUMA *)ERROR_PTR("line neither horiz nor vert", procName, NULL);
-    if (factor < 1) {
-        L_WARNING("factor must be >= 1; setting to 1", procName);
-        factor = 1;
-    }
-
-    na = numaCreate(0);
-    if (direction == L_HORIZONTAL_LINE) {
-        numaSetXParameters(na, x1, factor);
-        for (i = x1; i <= x2; i += factor) {
-            pixGetPixel(pixs, i, y1, &val);
-            numaAddNumber(na, val);
-        }
-    } else if (direction == L_VERTICAL_LINE) {
-        numaSetXParameters(na, y1, factor);
-        for (i = y1; i <= y2; i += factor) {
-            pixGetPixel(pixs, x1, i, &val);
-            numaAddNumber(na, val);
-        }
-    }
-
-    return na;
-}
-
-
-/*!
- *  pixAverageOnLine()
- *
- *      Input:  pixs (1 bpp or 8 bpp; no colormap)
- *              x1, y1 (starting pt for line)
- *              x2, y2 (end pt for line)
- *              factor (sampling; >= 1)
- *      Return: average of pixel values along line, or null on error.
- *
- *  Notes:
- *      (1) The line must be either horizontal or vertical, so either
- *          y1 == y2 (horizontal) or x1 == x2 (vertical).
- *      (2) If horizontal, x1 must be <= x2.
- *          If vertical, y1 must be <= y2.
- *          characterize the intensity smoothness along a line.
- *      (3) Input end points are clipped to the pix.
- */
-l_float32
-pixAverageOnLine(PIX     *pixs,
-                 l_int32  x1,
-                 l_int32  y1,
-                 l_int32  x2,
-                 l_int32  y2,
-                 l_int32  factor)
-{
-l_int32    i, j, w, h, d, direction, count, wpl;
-l_uint32  *data, *line;
-l_float32  sum;
-
-    PROCNAME("pixAverageOnLine");
-
-    if (!pixs)
-        return ERROR_INT("pixs not defined", procName, 1);
-    pixGetDimensions(pixs, &w, &h, &d);
-    if (d != 1 && d != 8)
-        return ERROR_INT("d not 1 or 8 bpp", procName, 1);
-    if (pixGetColormap(pixs))
-        return ERROR_INT("pixs has a colormap", procName, 1);
-    if (x1 > x2 || y1 > y2)
-        return ERROR_INT("x1 > x2 or y1 > y2", procName, 1);
-    if (y1 == y2) {
-        x1 = L_MAX(0, x1);
-        x2 = L_MIN(w - 1, x2);
-        y1 = L_MAX(0, L_MIN(y1, h - 1));
-        direction = L_HORIZONTAL_LINE;
-    }
-    else if (x1 == x2) {
-        y1 = L_MAX(0, y1);
-        y2 = L_MIN(h - 1, y2);
-        x1 = L_MAX(0, L_MIN(x1, w - 1));
-        direction = L_VERTICAL_LINE;
-    }
-    else
-        return ERROR_INT("line neither horiz nor vert", procName, 1);
-    if (factor < 1) {
-        L_WARNING("factor must be >= 1; setting to 1", procName);
-        factor = 1;
-    }
-
-    data = pixGetData(pixs);
-    wpl = pixGetWpl(pixs);
-    sum = 0;
-    if (direction == L_HORIZONTAL_LINE) {
-        line = data + y1 * wpl;
-        for (j = x1, count = 0; j <= x2; count++, j += factor) {
-            if (d == 1)
-                sum += GET_DATA_BIT(line, j);
-            else  /* d == 8 */
-                sum += GET_DATA_BYTE(line, j);
-        }
-    }
-    else if (direction == L_VERTICAL_LINE) {
-        for (i = y1, count = 0; i <= y2; count++, i += factor) {
-            line = data + i * wpl;
-            if (d == 1)
-                sum += GET_DATA_BIT(line, x1);
-            else  /* d == 8 */
-                sum += GET_DATA_BYTE(line, x1);
-        }
-    }
-
-    return sum / (l_float32)count;
-}
-
-
-/*!
- *  pixAverageIntensityProfile()
- *
- *      Input:  pixs (any depth; colormap OK)
- *              fract (fraction of image width or height to be used)
- *              dir (averaging direction: L_HORIZONTAL_LINE or L_VERTICAL_LINE)
- *              first, last (span of rows or columns to measure)
- *              factor1 (sampling along fast scan direction; >= 1)
- *              factor2 (sampling along slow scan direction; >= 1)
- *      Return: na (of reversal profile), or null on error.
- *
- *  Notes:
- *      (1) If d != 1 bpp, colormaps are removed and the result
- *          is converted to 8 bpp.
- *      (2) If @dir == L_HORIZONTAL_LINE, the intensity is averaged
- *          along each horizontal raster line (sampled by @factor1),
- *          and the profile is the array of these averages in the
- *          vertical direction between @first and @last raster lines,
- *          and sampled by @factor2.
- *      (3) If @dir == L_VERTICAL_LINE, the intensity is averaged
- *          along each vertical line (sampled by @factor1),
- *          and the profile is the array of these averages in the
- *          horizontal direction between @first and @last columns,
- *          and sampled by @factor2.
- *      (4) The averages are measured over the central @fract of the image.
- *          Use @fract == 1.0 to average across the entire width or height.
- */
-NUMA *
-pixAverageIntensityProfile(PIX       *pixs,
-                           l_float32  fract,
-                           l_int32    dir,
-                           l_int32    first,
-                           l_int32    last,
-                           l_int32    factor1,
-                           l_int32    factor2)
-{
-l_int32    i, j, w, h, d, start, end;
-l_float32  ave;
-NUMA      *nad;
-PIX       *pixr, *pixg;
-
-    PROCNAME("pixAverageIntensityProfile");
-
-    if (!pixs)
-        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
-    if (fract < 0.0 || fract > 1.0)
-        return (NUMA *)ERROR_PTR("fract < 0.0 or > 1.0", procName, NULL);
-    if (dir != L_HORIZONTAL_LINE && dir != L_VERTICAL_LINE)
-        return (NUMA *)ERROR_PTR("invalid direction", procName, NULL);
-    if (first < 0) first = 0;
-    if (last < first)
-        return (NUMA *)ERROR_PTR("last must be >= first", procName, NULL);
-    if (factor1 < 1) {
-        L_WARNING("factor1 must be >= 1; setting to 1", procName);
-        factor1 = 1;
-    }
-    if (factor2 < 1) {
-        L_WARNING("factor2 must be >= 1; setting to 1", procName);
-        factor2 = 1;
-    }
-
-        /* Use 1 or 8 bpp, without colormap */
-    if (pixGetColormap(pixs))
-        pixr = pixRemoveColormap(pixs, REMOVE_CMAP_TO_GRAYSCALE);
-    else
-        pixr = pixClone(pixs);
-    pixGetDimensions(pixr, &w, &h, &d);
-    if (d == 1)
-        pixg = pixClone(pixr);
-    else
-        pixg = pixConvertTo8(pixr, 0);
-
-    nad = numaCreate(0);  /* output: samples in slow scan direction */
-    numaSetXParameters(nad, 0, factor2);
-    if (dir == L_HORIZONTAL_LINE) {
-        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)w);
-        end = w - start;
-        if (last > h - 1) {
-            L_WARNING("last > h - 1; clipping", procName);
-            last = h - 1;
-        }
-        for (i = first; i <= last; i += factor2) {
-            ave = pixAverageOnLine(pixg, start, i, end, i, factor1);
-            numaAddNumber(nad, ave);
-        }
-    } else if (dir == L_VERTICAL_LINE) {
-        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)h);
-        end = h - start;
-        if (last > w - 1) {
-            L_WARNING("last > w - 1; clipping", procName);
-            last = w - 1;
-        }
-        for (j = first; j <= last; j += factor2) {
-            ave = pixAverageOnLine(pixg, j, start, j, end, factor1);
-            numaAddNumber(nad, ave);
-        }
-    }
-
-    pixDestroy(&pixr);
-    pixDestroy(&pixg);
-    return nad;
-}
-
-
-/*!
- *  pixReversalProfile()
- *
- *      Input:  pixs (any depth; colormap OK)
- *              fract (fraction of image width or height to be used)
- *              dir (profile direction: L_HORIZONTAL_LINE or L_VERTICAL_LINE)
- *              first, last (span of rows or columns to measure)
- *              minreversal (minimum change in intensity to trigger a reversal)
- *              factor1 (sampling along raster line (fast scan); >= 1)
- *              factor2 (sampling of raster lines (slow scan); >= 1)
- *      Return: na (of reversal profile), or null on error.
- *
- *  Notes:
- *      (1) If d != 1 bpp, colormaps are removed and the result
- *          is converted to 8 bpp.
- *      (2) If @dir == L_HORIZONTAL_LINE, the the reversals are counted
- *          along each horizontal raster line (sampled by @factor1),
- *          and the profile is the array of these sums in the
- *          vertical direction between @first and @last raster lines,
- *          and sampled by @factor2.
- *      (3) If @dir == L_VERTICAL_LINE, the the reversals are counted
- *          along each vertical column (sampled by @factor1),
- *          and the profile is the array of these sums in the
- *          horizontal direction between @first and @last columns,
- *          and sampled by @factor2.
- *      (4) For each row or column, the reversals are summed over the
- *          central @fract of the image.  Use @fract == 1.0 to sum
- *          across the entire width (of row) or height (of column).
- *      (5) @minreversal is the relative change in intensity that is
- *          required to resolve peaks and valleys.  A typical number for
- *          locating text in 8 bpp might be 50.  For 1 bpp, minreversal
- *          must be 1.
- *      (6) The reversal profile is simply the number of reversals
- *          in a row or column, vs the row or column index.
- */
-NUMA *
-pixReversalProfile(PIX       *pixs,
-                   l_float32  fract,
-                   l_int32    dir,
-                   l_int32    first,
-                   l_int32    last,
-                   l_int32    minreversal,
-                   l_int32    factor1,
-                   l_int32    factor2)
-{
-l_int32   i, j, w, h, d, start, end, nr;
-NUMA     *naline, *nad;
-PIX      *pixr, *pixg;
-
-    PROCNAME("pixReversalProfile");
-
-    if (!pixs)
-        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
-    if (fract < 0.0 || fract > 1.0)
-        return (NUMA *)ERROR_PTR("fract < 0.0 or > 1.0", procName, NULL);
-    if (dir != L_HORIZONTAL_LINE && dir != L_VERTICAL_LINE)
-        return (NUMA *)ERROR_PTR("invalid direction", procName, NULL);
-    if (first < 0) first = 0;
-    if (last < first)
-        return (NUMA *)ERROR_PTR("last must be >= first", procName, NULL);
-    if (factor1 < 1) {
-        L_WARNING("factor1 must be >= 1; setting to 1", procName);
-        factor1 = 1;
-    }
-    if (factor2 < 1) {
-        L_WARNING("factor2 must be >= 1; setting to 1", procName);
-        factor2 = 1;
-    }
-
-        /* Use 1 or 8 bpp, without colormap */
-    if (pixGetColormap(pixs))
-        pixr = pixRemoveColormap(pixs, REMOVE_CMAP_TO_GRAYSCALE);
-    else
-        pixr = pixClone(pixs);
-    pixGetDimensions(pixr, &w, &h, &d);
-    if (d == 1) {
-        pixg = pixClone(pixr);
-        minreversal = 1;  /* enforce this */
-    }
-    else
-        pixg = pixConvertTo8(pixr, 0);
-
-    nad = numaCreate(0);  /* output: samples in slow scan direction */
-    numaSetXParameters(nad, 0, factor2);
-    if (dir == L_HORIZONTAL_LINE) {
-        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)w);
-        end = w - start;
-        if (last > h - 1) {
-            L_WARNING("last > h - 1; clipping", procName);
-            last = h - 1;
-        }
-        for (i = first; i <= last; i += factor2) {
-            naline = pixExtractOnLine(pixg, start, i, end, i, factor1);
-            numaCountReversals(naline, minreversal, &nr, NULL);
-            numaAddNumber(nad, nr);
-            numaDestroy(&naline);
-        }
-    } else if (dir == L_VERTICAL_LINE) {
-        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)h);
-        end = h - start;
-        if (last > w - 1) {
-            L_WARNING("last > w - 1; clipping", procName);
-            last = w - 1;
-        }
-        for (j = first; j <= last; j += factor2) {
-            naline = pixExtractOnLine(pixg, j, start, j, end, factor1);
-            numaCountReversals(naline, minreversal, &nr, NULL);
-            numaAddNumber(nad, nr);
-            numaDestroy(&naline);
-        }
-    }
-
-    pixDestroy(&pixr);
-    pixDestroy(&pixg);
-    return nad;
-}
-
-
-/*---------------------------------------------------------------------*
  *                           Clip to Foreground                        *
  *---------------------------------------------------------------------*/
 /*!
